X J D I C   V1.0 

INTRODUCTION

XJDIC  is an electronic Japanese-English dictionary program designed to operate 
in the X11 window environment with  Japanese  input  and  output  support  from 
programs  such  as  kterm and kinput, or from from the environment itself (e.g. 
aixterm with Japanese language enabled).  It is based on JDIC & JREADER which 
were developed to run under MS-DOS on IBM PCs or clones. 

XJDIC functions as: 

(a)  an  English  to  Japanese  dictionary  (eiwa  jiten),  searching  for  and 
displaying entries for key-words entered in English; 

(b) a Japanese to English dictionary (waei jiten), searching for and displaying 
entries for keywords  or  phrases  entered  in  Japanese  (kanji,  hiragana  or 
katakana); 

(c) a Japanese-English Character dictionary (kanei jiten), capable of selecting 
kanji characters by JIS code, radical, stroke count, Nelson Index number or 
reading,  and displaying compounds containing that kanji. 

XJDIC is typically run in a window of its own.  The user can then use  it as a 
free-standing on-line dictionary. It can also be used as an accessory when 
reading or writing text in another window (e.g.  reading the "fj" Japanese news 
groups.) Strings of text, either English or Japanese,  can be moved to and from 
XJDIC using X11's mouse "cut-and-paste" operations. 
         
The source code, documentation and dictionaries of XJDIC are hereby released to 
the  "public  domain".  All  usage  of this program is at the user's risk,  and 
there is no warranty on its performance.  Copies  may  be  distributed  by  any 
means,  but  at  no  charge  apart  from  that  of the distribution medium.  No 
modifications may be made to the  software  without  the  author's  permission, 
except where minor changes are required to install the software on a particular 
platform.  The  software  is  not  to  be  incorporated into any other software 
product. 

All the Japanese displayed by XJDIC is in kana and kanji, so if you cannot read 
at least hiragana and katakana,  this is not the program for  you.  The  author 
has no intention whatsover of producing a version using romanized Japanese. 

OPERATION

The invocation of XJDIC is: 

    XJDIC <options> 

The command line options are: 

-l nn 

the number of lines of dictionary display produced at a time.  The  default  is 
set  by  the  MAXLINES  #define (currently 20).  After this number of lines are 
displayed,  there is a prompt giving the user the choice of having  more  lines 
displayed, or abandoning the search. 

-d dictionary-path_and_filename

the path and file-name of  the  Japanese-English  dictionary  to  use.  If  not 
present,  the  dictionary file "EDICT" will be used,  along with the index file 
"EDICT.XJDX".  These must be either in the current directory,  or the directory 
specified in the XJDIC environment variable. 

-k kanji_dictionary-path_and_filename

the  path  and  file-name of the Kanji dictionary to use.  If not present,  the 
dictionary  file  "KANJIDIC"  will  be  used,   along  with  the   index   file 
"KANJIDIC.XJDX".  These  must  be  either  in  the  current  directory,  or the 
directory specified in the XJDIC environment variable. 

-j japanese_output_code_type (e or s)

XJDIC uses "New-JIS" codes as its default output method. This is quite
acceptable if you are running under kterm. Some other environments which are 
internationalized (e.g. aixterm) can only handle EUC or Shift-JIS codes. XJDIC 
can be made to output in these codes by the "-j e" or "-j s" command-line 
options.

-h

this option results in the display of a simple summary of command-line
options.

ENTERING SEARCH KEYS 

(a) Japanese-English Dictionary

XJDIC operates in two modes: Japanese-English Dictionary, and Kanji Dictionary. 

In  the  case  of  the Japanese-English Dictionary,  search keys are entered in 
response to the "XJDIC SEARCH KEY:"  prompt.  Search  keys  can  be  either  in 
English  (entered directly from the keyboard) or kana and/or kanji (entered via 
a  "front-end"  program  such  as kinput,  or cut from a window using X11 mouse 
operations.) 

A multi-line display will be produced  of  all  the  dictionary  entries  which 
contain matches with the search key.  The display format is: 

     matched_word [kanji] (yomikata) english_1, english_2, etc 

where  "matched_word"  is  either English or Japanese,  depending on the search 
key.  If the search key was kana (i.e.  the match was  on  the  yomikata),  the 
separate yomikata display is omitted. 

A line is only displayed once per search,  regardless of the number of  matches 
which occur within it. 

If the search resulted in more entries than will fit on  a  screen,  a  further 
prompt  occurs  at the bottom of the screen giving you the option of requesting 
the next screen-full.  Once all the matches on a key are exhausted, the keyword 
is shortened by one character, and the display is continued. 

The matching of kana keys is insensitive to whether they  are  in  katakana  or 
hiragana,  however  note  that  the  convention for long vowels differs between 
Japanese words and gairaigo.  Matching of English keywords  is  insensitive  to 
case. 

The display is in "dictionary" order for the words matched,  i.e.  alphabetical 
for the English search,  and JIS code order for the Japanese search.  JIS order 
is  very close to the "gojuuon" kana order used in Japanese dictionaries except 
that it separates the syllables with nigori and maru. 

(b) Kanji Dictionary 

XJDIC has the capability to select individual kanji characters by a variety  of 
techniques, and to display information about that character.  The character can 
then be "cut" into the main dictionary search to display all dictionary entries 
starting with or containing that particular character. 

The  search of the Kanji Dictionary is triggered by entering "\",  which causes 
the "KANJI  LOOKUP  TYPE:"  prompt  to  appear.  The  kanji  lookup  types  are 
specified by entering a further single character: 

J  -  by its "JIS" code.  This is the standard 4-digit hexadecimal code used to 
identify each Japanese character. 

N - by its "Nelson" index number.  This refers the kanji index numbers used  by 
the  late Professor Andrew N.  Nelson in his famous "Japanese-English Character 
Dictionary", published by Tuttle.  Over 4000 kanji in XJDIC's files have Nelson 
numbers.  

K - by the reading (or yomikata) of a character.  Both on and kun readings  are 
used  for this search.  A display of all kanji with that particular yomikata is 
produced,  and the desired character can be selected using the mouse.  A  kanji 
can also be entered if its characteristics are to be examined. 

S  -  by  its  stroke  count.  A display of all the characters with that stroke 
count is produced.  As above,  the desired character can be  selected  for  the 
display of its compounds. 

B  - by its primary radical (Bushu).  The Bushu numbers used by XJDIC are those 
from Nelson (as depicted inside the front cover of Nelson's  "Japanese  English 
Character Dictionary"). To use this method, you will need to have a copy of the 
Nelson radical table with you. 

M - by its English "meaning".

R - initiates a display of all the Bushu along with their numbers.

Once  a  kanji  has  been  identified by any of the techniques described above, 
XJDIC displays the following information about it: 

        KANJI character 

        JIS code in hexadecimal 
        
        Nelson No 
        
        Bushu No 
        
        Stroke Count 
        
        Grade (in which the kanji is taught in Japan) 
        
        "on" readings of the character, mostly in katakana 
        
        "kun" readings in hiragana 
        
        meanings ascribed to the kanji (mostly taken from Heisig  and  Nelson).  
        An  A  is  included  if the kanji is one of the 881 "essential" kyouiku 
        kanji, and a B if it is one of the remaining jouyou kanji. 

At  this stage,  the user can request a display of all the compounds containing 
that character by using the mouse to select the kanji and entering  it  as  the 
search key for a main dictionary search. 

XJDIC  has  two modes for displaying compounds containing a particular sequence 
of one or more kanji.  Either the display is restricted to only those compounds 
which begin with the sequence,  or all compounds containing the sequence can be 
displayed.  When  XJDIC loads it is in the more limited mode,  however the mode 
can be toggled using the "/" key. 

EXITING

To exit XJDIC, type "bye". Ctrl-C will work, but may leave echo turned off.

ON-LINE HELP

Basic operating information can be obtained by typing "?". A summary of the
command-line options can be obtained by invoking XJDIC with the "-h" option.

JAPANESE CODES

Kterm can operate with the JIS, EUC or Shift-JIS code sets (as specified by the 
command-line,  or  by Ctrl-middle_mouse_button).  XJDIC uses EUC internally and 
displays in (new) JIS, EUC or Shift-JIS. New-JIS is the default, and the others 
can be specified by command-line option. It will accept input in any code type,  
but  as  the discrimination   between  EUC   and  Shift-JIS  cannot  always  be  
determined accurately, it is recommended that either JIS or EUC mode is used. 

In fact, XJDIC's operation is smoothest in JIS mode. This is because it detects 
the closing "shift-out" sequence which is present in this code, and immediately 
invokes the dictionary search.  Thus it is possible to  cut  a  string  from  a 
document being read, and initiate a dictionary scan, solely by using the mouse. 
(Entering a kana/kanji string in response to almost all of XJDIC's prompts will 
result in a dictionary search on that string.) 

DICTIONARIES

XJDIC depends for its performance on a pair of dictionary files; a Japanese <-> 
English dictionary and a Kanji dictionary, and a file of radicals.  It has been 
designed to work with the EDICT dictionary,  which is the author's extension of 
MOKE's EDICT,  and the KANJIDIC character  dictionary  file,  compiled  by  the 
author from various sources.  EDICT has now over 25,000 entries, while KANJIDIC 
has  an  entry  for  each  of the JIS1 and JIS2 kanji.  The file of radicals is 
RADICALS.TM, compiled by Theresa Martin for the earlier JDIC program 

The format each entry of EDICT is: 

Kanji [kana] /english_1/english_2/..../ 

or 

kana /english_1/english_2/..../ 

KANJIDIC is a combination the files JIS1DETL.LST and JIS2DETL.LST. It has the 
format:

Kanji hex_JIS_code Nnnnn Bnnn Snn Gn on_reading(s) kun_reading(s) {meaning(s)}

where  N,  B,  S and G flag the Nelson number,  Bushu number,  stroke count and 
(school) grade respectively.  On  readings  are  mostly  in  katakana  and  kun 
readings in hiragana. 

LOGGING

Users of the author's JREADER program will notice that  XJDIC  has  no  logging 
facilities.  This  is  because  the  X11 environment makes logging possible via 
another window running an editor such as  jstevie  or  nemacs  against  a 
logfile. 

JREADER  has  a  facility  to look up kanji compounds which are not in EDICT in 
MOKE's Kanji->Kana file (WSKTOK.DAT),  and to  log  the  match  for  the  later 
addition of a translation. If you wish to have this capability in XJDIC, obtain 
the  file  WDICT  and  either incorporate  it  into  EDICT, or run a separate 
window with XJDIC running with WDICT as the dictionary.  WDICT  contains  all  
the WSKTOK.DAT  entries  (kanji  plus  kana)  not currently in EDICT as well.  
(See XJDIC.INSTALL.)  If a match is found against one of these entries,  you 
can use the mouse to cut it into the logfile. 

INSTALLATION 
            
See the document XJDIC.INSTALL for information on compiling the  XJDIC  program 
and setting up the dictionary files and index files. 

Make sure you have the XJDIC executable in your path,  and that the dictionary, 
index and radical files  are  either  in  your  current  directory  or  in  the 
directory specified by the XJDIC environment variable. 

AUTHOR'S COMMENT 

XJDIC is port/rework of my earlier JDIC/JREADER programs which were written for 
PCs or clones. Most of the code came from JREADER. 

In  producing  XJDIC  I  have  relied  heavily  on  the  Japanese  input/output 
environment such as is provided by kterm and kinput,  with the result that 
XJDIC is only a fraction  the size of either JDIC or JREADER.  Also I took a 
different approach with  the  kanji  dictionary.  Whereas  in  JDIC/JREADER  I  
use  a  compressed dictionary  file  with  separate  index files for Nelson 
number,  stroke count, yomikata,  etc.  (originally devised by Stephen Chung 
for his JWP),  in XJDIC I have used the same indexing and lookup approach as 
with the main dictionary. 

XJDIC's  output  format  is  perhaps  not  quite as elegant as that in JDIC and 
JREADER,  largely because it does not  have  as  much  control  over  essential 
aspects such as window and font size.  This is more than compensated for by the 
inherent advantages of the windowing environment. 

My  thanks  to the many people who helped and gave advice to me,  and to Philip 
Moore, Ken Lunde, Scott Trent and the other XJDIC beta-testers. 

A special mention to Andrew Moore, my Department's sysadmin,  who laboured long 
and  hard to install wnn/kterm/kinput on our DEC5000/3000/2000 (Ultrix) network 
without knowing a word of Japanese. 

With the release of XJDIC, the source is now available to the world. Any takers 
for a Macintosh KanjiTalk port? 

As ever comments and constructive criticism are welcome. 

Jim Breen 
Department of Robotics & Digital Technology 
Monash University 
Melbourne, Australia 
(jwb@capek.rdt.monash.edu.au) 
Jan 1991 - August 1992 
